import java.io.*;
import java.util.*;
import java.sql.*;

// Methods for reporting changes to a MySQL-database
class ttchess_mysql extends ttchess_common {

	static String server		= "tmc3.hs.se";
	static String user		= "";
	static String pass		= "";
	static String dbase		= "elitserien";

	static String update_table	= "games";

    static Connection conn = null;
    static Statement stmt = null;

    static boolean rotated=false;

	static String connect()
	{
		try
		{
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			conn = DriverManager.getConnection("jdbc:mysql://"+server+"/"+dbase+"?user="+user+"&password="+pass);
			return "";
		}
		catch (SQLException e)
		{
			return e.getSQLState();
		}
		catch (Exception e)
		{
			return "0";
		}
	}

	static boolean disconnect()
	{
		if (conn != null) {
			try
			{
				conn.close();
				return true;
			}
			catch (SQLException SQLE)
			{
				return false;
			}
		}
		else
			return false;
	}

	static String execute(String expr)
	{
		try
		{
			stmt = null;
			stmt = conn.createStatement();
			stmt.executeUpdate(expr);
			return "";
		}
		catch (SQLException e)
		{
			return e.getSQLState();
		}
		catch (Exception e)
		{
			return "0";
		}
		finally
		{
			if (stmt != null) {
				try
				{
					stmt.close();
				}
				catch (SQLException SQLE)
				{
					;
				}
			}
		}
	}

	static String snapshot2fen (ttchess_snapshot b)
	{
		StringBuffer s = new StringBuffer(100);
		int counter = 0;
		for (int i=0; i<8; i++)
		{
			for (int j=0; j<8; j++)
			{
				if ((counter != 0) && (b.pieces[(i*8)+j] != EMPTY))
				{
					s.append(counter);
					counter = 0;
				}
				switch(b.pieces[(i*8)+j])
				{
					case WPAWN:		s.append("P"); break;
					case WROOK: 	s.append("R"); break;
					case WKNIGHT: 	s.append("N"); break;
					case WBISHOP: 	s.append("B"); break;
					case WKING: 	s.append("K"); break;
					case WQUEEN: 	s.append("Q"); break;
					case BPAWN: 	s.append("p"); break;
					case BROOK: 	s.append("r"); break;
					case BKNIGHT: 	s.append("n"); break;
					case BBISHOP: 	s.append("b"); break;
					case BKING: 	s.append("k"); break;
					case BQUEEN: 	s.append("q"); break;
					default: 		counter++; break;
				}
			}
			if (counter != 0)
				s.append(counter);
			s.append("/");
			counter = 0;
		}
		String outfen= s.toString().substring(0,s.toString().length()-1);



			/** This is just for now, static rotated boards!! **/
			switch(b.board.address.intValue()){
			case 3737:
			case 3811:
			case 2896:
			case 3740:
			case 3588:
			case 2897:
			default: 
			    rotated=false; break;
			}

			if(rotated){
			    String newFen="";
			    for(int i=outfen.length()-1;i>=0;i--){
				newFen += outfen.charAt(i);
			    }
			    outfen=newFen;
			}

			return outfen;

	}

	static void update_snapshot(ttchess_snapshot b)
	{
		if (conn != null)
		{
			String fen = snapshot2fen(b);
			String turn;


			if(rotated){
			    if(b.isWhiteTurn()) turn="Black";
			    else turn="White";
			}
			else{
			    if(b.isWhiteTurn()) turn="White";
			    else turn="Black";
			}


			String sql_command = "UPDATE "+update_table+" SET fen = '"+fen+"',wtime='"+b.getTimeWhite()+"',btime='"+b.getTimeBlack()+"',turn='"+turn+"' WHERE dgt_active like '%Fen%' AND dgt_board = "+b.board.address;
			//System.out.println(sql_command);
			execute(sql_command);

			System.out.println(b.board.address+" "+fen+" "+b.getTimeWhite()+" "+b.getTimeBlack()+" "+turn.substring(0,1));


			/* ADD (should check previous sql return instead, if no rows affected then run this) 
                           for now we assume that the database has UNIQUE dgt_board*/
			//			execute("insert into "+update_table+" set fen='" + fen + "', dgt_active='Connected,Fen,Moves', dgt_board="+b.board.address);
		}
	}

	static void update_moves(String moves, String movestable, int board_id)
	{
		if (conn != null)
		{
		    int t=0;
		    if(moves.length()>20) t=moves.length()-20; 
		    System.out.println(board_id + " Moves: " + moves.substring(t));

			String sql_command = "UPDATE games SET moves = '"+moves+"' WHERE dgt_active like '%Moves%' AND dgt_board = "+board_id;
			//			System.out.println(sql_command);
			execute(sql_command);
		}
	}



}
